#include<stdio.h>
#include<stdlib.h>
#include<math.h>

long double LogFact(int x){
	if(x<2)	return 0;
	else	return ( log10(x) + LogFact(x-1) ) ;
}

//log_fisher:probability density
double logfisher(int a, int b , int c, int d){
	double tmp1,tmp2,tmp3;
	tmp1 = LogFact(a+b) - LogFact(a) - LogFact(b);
	tmp2 = LogFact(c+d) - LogFact(c) - LogFact(d);
	tmp3 = LogFact(a+b+c+d) - LogFact(a+c) - LogFact(b+d);
	return ( tmp1 + tmp2 - tmp3 );
}

//log_fisher : double-tailed
double fisher_twoside(int a , int b , int c , int d){
	int ab = a + b;
	int ac = a + c;
	int num = a + b + c + d;
	int min = ( ab  > ac)? ac : ab;
	double p = 0.0;
	int a2,b2,c2,d2;
	double s,s2;
	s = a*d -b*c;
	
	for( a2 = 0 ; a2 <= min ; a2++){
		b2 = ab - a2;
		c2 = ac - a2;
		d2 = num - a2 - b2 - c2;
		s2 = a2*d2 - b2*c2;
		
		if( d2 >= 0 && fabs(s) <= fabs(s2) ){
			p += pow( 10 , logfisher(a2,b2,c2,d2)   );
		}
	}
	return p;
}


double calc_xi(int a, int b , int c , int d){
	int ab = a+b;
	int ac = a+c;
	int num = a+b+c+d;
	
	double a2 = (double)ac * ab / num;
	double b2 = ab - a2;
	double c2 = ac - a2;
	double d2 = num - a2- b2 - c2;
	
	double xi;
	xi = pow(a-a2 ,2)/a2 + pow(b-b2 ,2)/b2 + pow(c-c2 ,2)/c2 + pow(d-d2 ,2)/d2;
	
	return xi;
}


int a = 20;
int b = 8;
int c = 12;
int d = 45;

int main(void){
	double p_fisher, xi;
	
	FILE *fp;
	fp = fopen("proble3_6_1.dat","w");
	
	p_fisher = fisher_twoside(a,b,c,d);
	fprintf(fp, "p  = %f\t(significant if p  < 0.05)\n",p_fisher);
	
	xi = calc_xi(a,b,c,d);
	fprintf( fp, "xi = %f\t(significant if xi > 3.841)\n" , xi);
	
	fclose(fp);
	return 0;
}
